from PyQt5.QtWidgets import QFormLayout, QLineEdit, QSpinBox, QWidget

from dip.ui import Application, Bindings


# Every application needs an Application.
app = Application()

# Create the model.
model = dict(name='', age=0)

# Create the view programmatically.
layout = QFormLayout()
layout.addRow("Name", QLineEdit(objectName='name_editor'))
layout.addRow("Age", QSpinBox(objectName='age_editor'))

view = QWidget(windowTitle="Bindings")
view.setLayout(layout)

# Define the bindings.
bindings = Bindings(name_editor='name', age_editor='age')

# Bind the view to the model.
bindings.bind(view, model)

# Make the instance of the view visible.
view.show()

# Enter the event loop.
app.execute()

# Show the value of the model.
print("Name:", model['name'])
print("Age:", model['age'])
